<?php

namespace Drupal\mcapi_limits\Plugin;

use Drupal\mcapi\Entity\WalletInterface;
use Drupal\Core\Plugin\PluginFormInterface;
use Drupal\Component\Plugin\ConfigurableInterface;
use Drupal\Component\Plugin\DependentPluginInterface;

/**
 * Interface for Limits object.
 */
interface McapiLimitsInterface extends ConfigurableInterface, DependentPluginInterface, PluginFormInterface {

  /**
   * Get the limits according to the plugin settings.
   *
   * @param WalletInterface $wallet
   *   The wallet.
   *
   * @return array
   *   Native currency amounts keyed with 'min' and 'max'.
   */
  public function getLimits(WalletInterface $wallet);

}
